<template>
  <el-form
    :model="customerForm"
    :rules="rules"
    ref="customerForm"
    label-width="120px"
  >
  <el-row>
    <el-col :xs="24" :sm="14" :md="12" :lg="10" :xl="10">
      <div class="container">
        <div class="sub-container">
          <el-row :gutter="20" style="text-align: center;">
            <div class="text-container">
              <span>Información del cliente</span>
            </div>
            <el-col :span="24">
              <div class="block avatar"><el-avatar :size="150" :src="avatar"></el-avatar></div>
            </el-col>
          </el-row>
          
            <el-form-item label="Nombre" prop="fullName">
              <el-input size="medium" v-model="customerForm.fullName"></el-input>
            </el-form-item>
            <el-form-item label="Correo" prop="email">
              <el-input size="medium" v-model="customerForm.email"></el-input>
            </el-form-item>
            <el-form-item>
              <el-button type="primary" @click="saveCustomer('customerForm')">Crear</el-button>
              <el-button @click="clearFields('customerForm')">Cancelar</el-button>
            </el-form-item>
        </div>
      </div>
    </el-col>
    <el-col :xs="24" :sm="14" :md="12" :lg="10" :xl="10">
      <div class="container">
        <div class="sub-container">
          <el-row :gutter="20" style="text-align: center;">
            <div class="text-container">
              <span>Dirección del cliente</span>
            </div>
          </el-row>
            <el-form-item label="País" prop="address.country">
              <el-input size="medium" v-model="customerForm.address.country"></el-input>
            </el-form-item>
            <el-form-item label="Subdivisión" prop="address.subdivision">
              <el-input size="medium" v-model="customerForm.address.subdivision"></el-input>
            </el-form-item>
            <el-form-item label="Ciudad" prop="address.city">
              <el-input size="medium" v-model="customerForm.address.city"></el-input>
            </el-form-item>
            <el-form-item label="Cod. Postal" prop="address.postalCode">
              <el-input size="medium" v-model="customerForm.address.postalCode"></el-input>
            </el-form-item>
            <el-form-item label="Dirección" prop="address.shortAddress">
              <el-input size="medium" v-model="customerForm.address.shortAddress"></el-input>
            </el-form-item>
        </div>
      </div>
    </el-col>
    <el-col :xs="24" :sm="14" :md="12" :lg="10" :xl="10">
      <div class="container">
        <div class="sub-container">
          <el-row :gutter="20" style="text-align: center;">
            <div class="text-container">
              <span>Información del contacto</span>
            </div>
          </el-row>
            <el-form-item label="Nombre" prop="contact.fullName">
              <el-input size="medium" v-model="customerForm.contact.fullName"></el-input>
            </el-form-item>
            <el-form-item label="Teléfono" prop="contact.phone">
              <el-input size="medium" v-model="customerForm.contact.phone"></el-input>
            </el-form-item>
            <el-form-item label="Ext." prop="contact.extension">
              <el-input size="medium" v-model="customerForm.contact.extension"></el-input>
            </el-form-item>
            <el-form-item label="Celular" prop="contact.mobile">
              <el-input size="medium" v-model="customerForm.contact.mobile"></el-input>
            </el-form-item>
            <el-form-item label="Correo" prop="contact.email">
              <el-input size="medium" v-model="customerForm.contact.email"></el-input>
            </el-form-item>
        </div>
      </div>
    </el-col>
  </el-row>
  </el-form>
</template>

<script>
export default {
  // async fetch({ store, error }) {
  //   await Promise.all([
  //     store.dispatch("inventory/api/category/fetchCategories"),
  //     store.dispatch("inventory/api/presentation/fetchPresentations")
  //   ]).catch(e => {
  //     error({ statusCode: 404, message: "cannot fetch categories or presentations" })
  //   })
  // },
  data() {
    return {
      avatar: "/avatar.png",
      customerForm: {
        fullName: "",
        email: "",
        address: {
          country: "",
          subdivision: "",
          city: "",
          postalCode: "",
          shortAddress: "",
          idCustomer: "00000000-0000-0000-0000-000000000000"
        },
        contact: {
          fullName: "",
          phone: "",
          extension: "",
          mobile: "",
          email: "",
          idCustomer: "00000000-0000-0000-0000-000000000000"
        }
      },
      rules: {
        fullName: [
          {
            required: true, message: "El nombre es requerido.", trigger: "blur"
          },
          {
            max: 200, message: "El nombre no puede ser mayor a 200 caracteres.", trigger: "blur"
          }
        ],
        email: [
          {
            required: true, message: "El correo es requerido.", trigger: "blur"
          },
          {
            type: "email", message: "Por favor ingrese un correo valido.", trigger: "blur"
          },
          {
            max: 150, message: "El correo no puede ser mayor a 150 caracteres.", trigger: "blur"
          }
        ],
        'address.country': [
          {
            required: true, message: "El país es requerido.", trigger: "blur"
          },
          {
            max: 50, message: "El país no puede ser mayor a 50 caracteres.", trigger: "blur"
          }
        ],
        'address.subdivision': [
          {
            required: true, message: "La subdivisión es requerida.", trigger: "blur"
          },
          {
            max: 50, message: "La subdivisión no puede ser mayor a 50 caracteres.", trigger: "blur"
          }
        ],
        'address.city': [
          {
            required: true, message: "La ciudad es requerida.", trigger: "blur"
          },
          {
            max: 50, message: "La ciudad no puede ser mayor a 50 caracteres.", trigger: "blur"
          }
        ],
        'address.postalCode': [
          {
            max: 20, message: "El código postal no puede ser mayor a 20 caracteres.", trigger: "blur"
          }
        ],
        'address.shortAddress': [
          {
            required: true, message: "La dirección es requerida.", trigger: "blur"
          },
          {
            max: 300, message: "La dirección no puede ser mayor a 300 caracteres.", trigger: "blur"
          }
        ],
        'contact.fullName': [
          {
            required: true, message: "El nombre es requerido.", trigger: "blur"
          },
          {
            max: 200, message: "El nombre no puede ser mayor a 200 caracteres.", trigger: "blur"
          }
        ],
        'contact.phone': [
          {
            max: 20, message: "El teléfono no puede ser mayor a 20 caracteres.", trigger: "blur"
          }
        ],
        'contact.extension': [
          {
            max: 50, message: "La extensión no puede ser mayor a 50 caracteres.", trigger: "blur"
          }
        ],
        'contact.mobile': [
          {
            required: true, message: "El teléfono móvil es requerido.", trigger: "blur"
          },
          {
            max: 20, message: "El teléfono móvil no puede ser mayor a 20 caracteres.", trigger: "blur"
          }
        ],
        'contact.email': [
          {
            required: true, message: "El correo es requerido.", trigger: "blur"
          },
          {
            type: "email", message: "Por favor ingrese un correo valido.", trigger: "blur"
          },
          {
            max: 150, message: "El correo no puede ser mayor a 150 caracteres.", trigger: "blur"
          }
        ],
      }
    };
  },
  computed: {
  },
  watch: {
  },
  mounted() {},
  methods: {
    clearFields(customerForm) {
      this.$refs[customerForm].resetFields();
    },
    saveCustomer(customerForm) {
      this.$refs[customerForm].validate(valid => {
        if (valid) {
            this.$store
            .dispatch("testnoova/api/customer/saveCustomer", this.customerForm)
            .then((res) => {
              console.log(res);
              this.$message({
                message: "Se ha guardado correctamente el cliente",
                type: "success"
              });
              this.$refs[customerForm].resetFields();
            })
          .catch(error => {
            if(error.response.status != 200) {
              this.$message.error(`ha ocurrido un error guardando el cliente: ${error.response.status}`);
            }
          });
        } else {
          this.$message({
            message: 'Hay errores en el formulario',
            type: 'warning'
          });
          return false;
        }
      });
    }
  }
};
</script>

<style>
.container:hover {
  box-shadow: 0 0 8px 0 rgba(232, 237, 250, 0.6),
    0 2px 4px 0 rgba(232, 237, 250, 0.5);
}
.container {
  border: 1px solid #ebebeb;
  border-radius: 3px;
  transition: 0.2s;
}
.container .sub-container {
  padding: 24px;
}
.avatar {
  padding-bottom: 20px;
}
.text-container {
  padding-top: 10px;
  padding-bottom: 20px;
}
</style>